/*
欢迎使用GGBoxPro插件模板
本文件是Auto.js的工程文件，
您需要使用Auto.js或Autox.js将其打包为apk后功能才能正常运行。
*/

"ui";
importClass(android.view.View);
importClass(android.graphics.Color);
importClass(android.graphics.drawable.GradientDrawable);
importClass("java.security.SecureRandom");
importClass("javax.crypto.spec.DESKeySpec");
importClass("javax.crypto.SecretKeyFactory");
importClass("javax.crypto.Cipher");

/*-------导入工程数据(在里面的代码不要动)-------*/
let zsbm = "";
let gcsj = {};
let rzsz = [];
let GGBox;
var Config = engines.myEngine().execArgv;
if (Config.gcsj == undefined) {
    let ggtxtlj = files.path(".//ggbox.txt");
    if (files.exists(ggtxtlj) && files.isFile(ggtxtlj)) {
        let gcsz = files.readBytes(ggtxtlj)
        try {
            gcsz = decryptDES(gcsz, "aijibiji");
            let gczf = new java.lang.String(gcsz);
            gcsj = JSON.parse(gczf);
        } catch (error) {
            toast("加载数据失败1");
            exit();
        }
    } else {
        let ggjslj = files.path(".//ggbox.js");
        if (files.exists(ggjslj) && files.isFile(ggjslj)) {
            try {
                GGBox = new require('ggbox.js');
                gcsj = GGBox.gcsj;
            } catch (error) {
                toast("加载数据失败2");
                exit();
            }
        } else {
            toast("无数据");
            exit();
        }
    }
    zsbm = JSON.parse(files.read(files.path(".//project.json"))).packageName;
} else {
    gcsj = Config.gcsj;
    zsbm = "com.aijibiji.ggboxpro";
}
/*-------导入工程数据(在里面的代码不要动)-------*/

//申请本地储存，用来存卡密等数据
var storage = storages.create("GGBoxPro_" + gcsj.gcm);

//执行命令时的root开关
let shell_root = false;

let djlj = files.path(".//777/xgdj/");
files.removeDir(djlj);
files.ensureDir(djlj);
for (let i = 0; i < gcsj.bmlb.length; i++) {
    files.create(files.join(djlj, gcsj.bmlb[i].bm) + "/");
}

//设置状态栏颜色
ui.statusBarColor("#303030");
//主页UI
ui.layout(
    <drawer id="drawer">
        <linear id="bg" orientation="vertical" bg="#212121">
            <toolbar id="zygjl" padding="0dp" bg="#303030" contentInsetStart="0dp" contentInsetStartWithNavigation="0dp" title="{{gcsj.gcm}}"/>
            <linear w="*" layout_weight="1" orientation="vertical">
                <card w="*" layout_weight="1" margin="20 20 20 0" cardElevation="3" cardCornerRadius="6" cardBackgroundColor="#303030">
                    <linear w="*" layout_weight="1" orientation="vertical">
                        <tabs id="tabs" bg="#424242"/>
                        <viewpager id="viewpager">
                            <ScrollView w="*" h="*">
                                <text id="bdgoga" w="*" h="auto" margin="8" textSize="14sp" textColor="#EFEFEF" text="{{gcsj.goga}}"/>
                            </ScrollView>
                            <ScrollView w="*" h="*">
                                <text id="ydgoga" w="*" h="auto" margin="8" textSize="14sp" textColor="#EFEFEF" text=""/>
                            </ScrollView>
                        </viewpager>
                    </linear>
                </card>
                <card  w="*" h="auto" margin="20 20 20 0" cardElevation="3" cardCornerRadius="6" cardBackgroundColor="#424242">
                    <linear w="*" h="auto" orientation="vertical">
                        <Switch id="root" w="*" h="auto" padding="8" textColor="#FFFFFF" text="ROOT" bg="#422754" foreground="?selectableItemBackground"/>
                        
                        <linear w="*" h="auto" padding="4 8 4 4"  gravity="center_vertical">
                            <img w="16" h="16" margin="4 0" layout_gravity="center" tint="#EFEFEF" src="drawable/ic_smartphone_black_48dp"/>
                            <text w="*" h="auto" textSize="12sp" textColor="#EFEFEF" text="分辨率：{{device.height+' x '+device.width}}"/>
                        </linear>
                        <linear w="*" h="auto" padding="4 0 4 4" gravity="center_vertical">
                            <img w="16" h="16" margin="4 0" layout_gravity="center" tint="#EFEFEF" src="drawable/ic_home_black_48dp"/>
                            <text w="*" h="auto" textSize="12sp" textColor="#EFEFEF" text="厂商品牌：{{device.brand}}"/>
                        </linear>
                        <linear w="*" h="auto" padding="4 0 4 4" gravity="center_vertical">
                            <img w="16" h="16" margin="4 0" layout_gravity="center" tint="#EFEFEF" src="drawable/ic_error_outline_black_48dp"/>
                            <text w="*" h="auto" textSize="12sp" textColor="#EFEFEF" text="设备型号：{{device.model}}"/>
                        </linear>
                        <linear w="*" h="auto" padding="4 0 4 8" gravity="center_vertical">
                            <img w="16" h="16" margin="4 0" layout_gravity="center" tint="#EFEFEF" src="drawable/ic_android_black_48dp"/>
                            <text w="*" h="auto" textSize="12sp" textColor="#EFEFEF" text="安卓版本：{{device.release+'（SDK：'+device.sdkInt+'）'}}"/>
                        </linear>
                    </linear>
                </card>
                <grid id="czlb" w="*" h="auto" margin="15 15 15 0" spanCount="2" >
                    <card layout_weight="1" h="auto" margin="5" cardElevation="3" cardCornerRadius="6" cardBackgroundColor="#5A5A5C" foreground="?selectableItemBackground">
                        <text w="*" h="auto" margin="10" gravity="center" textSize="14sp" textColor="#FFFFFF" text="{{this.m}}"/>
                    </card>
                </grid>
                <text w="*" h="auto" margin="10" gravity="center" textSize="12sp" textColor="#AAFFFFFF" text="Powered by GGBox Pro" />
            </linear>
        </linear>
        <linear id="dljm" w="*" layout_gravity="left" bg="#001E1F21">
            <linear w="*" h="*" orientation="vertical">
                
                <card id="yhxx" w="*" h="auto" margin="8" cardElevation="3" cardCornerRadius="4" cardBackgroundColor="#303030" foreground="?selectableItemBackground">
                    <frame w="*" h="auto">
                        <linear w="*" h="auto" gravity="center_vertical">
                            <img margin="8" layout_gravity="center" w="48" h="48" borderWidth="1" borderColor="#ffffff" circle="true" scaleType="fitXY" src="file://res/yhtx.jpg"/>
                            <linear layout_weight="1" h="auto" orientation="vertical">
                                <text id="yhm" w="auto" h="auto" textStyle="bold" textSize="14sp" textColor="#FFFFFF" text="未登录" lines="1" ellipsize="end"/>
                                <text id="yhs" w="auto" h="auto" textSize="12sp" alpha="0.6" textColor="#FFFFFF" text="AIJIBIJI GGBOX" lines="1" ellipsize="end"/>
                            </linear>
                        </linear>
                        <img id="viptb" w="40" h="40" layout_gravity="right|top" scaleType="fitXY" src="file://res/vip_n.png"/>
                    </frame>
                </card>
                
                <list id="cdlb" w="*" h="auto">
                    <card id="yhxx" w="*" h="auto" margin="8 0 8 8" cardElevation="3" cardCornerRadius="4" cardBackgroundColor="#303030" foreground="?selectableItemBackground">
                        <linear w="*" h="auto" margin="0 0 0 1" gravity="center_vertical" foreground="?selectableItemBackground">
                            <text layout_weight="1" h="auto" padding="8 0 0 0" textSize="14sp" textColor="#FAFAFA" text="{{this.mc}}" lines="1" ellipsize="end"/>
                            <img id="gbxfc" w="48" h="48" padding="12" scaleType="fitXY" tint="#DDDDDD" src="drawable/ic_chevron_right_black_48dp" />
                        </linear>
                    </card>
                </list>
            </linear>
        </linear>
    </drawer>
);

//设置滑动页面的标题
ui.viewpager.setTitles(["本地公告", "云端公告"]);
//让滑动页面和标签栏联动
ui.tabs.setupWithViewPager(ui.viewpager);
//删除滑动到底部的阴影
ui.viewpager.overScrollMode = View.OVER_SCROLL_NEVER;
ui.czlb.overScrollMode = View.OVER_SCROLL_NEVER;
ui.cdlb.overScrollMode = View.OVER_SCROLL_NEVER;
//监听root开关，设置执行命令时的模式
ui.root.on("check", (checked) => {
    if (checked) {
        if (!storage.get("shell_root")) {
            let jg = shell(files.path(".//777/isroot"), true);
        }
        shell_root = true;
        storage.put("shell_root", true);
    } else {
        shell_root = false;
        storage.put("shell_root", false);
    }
});
//让侧边栏空白区域被点击时候收回
ui.dljm.setOnTouchListener(function(view, event) {
    switch (event.getAction()) {
        case event.ACTION_UP:
            ui.drawer.closeDrawer(3);
            return true;
    }
    return true;
});
//第一次启动应用时尝试以root模式执行一次命令，如果成功将默认设置为root模式。
if (storage.get("shell_root") == undefined) {
    threads.start(function() {
        try {
            let wjlj = files.path(".//777/isroot");
            let jg = shell(wjlj, true);
            if (jg.code == 0) {
                shell_root = true;
                storage.put("shell_root", true);
                ui.run(function() {
                    ui.root.setChecked(true);
                })
            } else {
                storage.put("shell_root", false);
            }
        } catch (e) {
            storage.put("shell_root", false);
        }
    })
} else {
    shell_root = storage.get("shell_root");
    ui.root.setChecked(shell_root);
}

//当UI界面加载完成时，进行检测更新，获取公告，卡密自动登录等操作
ui.post(function() {
    if (gcsj.wlyz.kg) {
        threads.start(function() {
            检测更新();
            检查公告();
        })
    }
    threads.start(function() {
        let kami = storage.get("kami", "");
        if (gcsj.wlyz.kg && kami != "") {
            ui.run(function() {
                ui.yhm.setText(kami);
                ui.yhs.setText("登录中");
                ui.viptb.attr("src", "file://res/vip_n.png");
            })
            let kmdl = 卡密登录(kami);
            if (kmdl.cb) {
                ui.run(function() {
                    ui.yhm.setText(kami);
                    ui.yhs.setText("到期时间：" + kmdl.ts);
                    ui.viptb.attr("src", "file://res/vip_y.png");
                })
                toast("自动登录成功");
            } else {
                ui.run(function() {
                    ui.run(function() {
                        ui.yhm.setText("未登录");
                        ui.yhs.setText("AIJIBIJI GGBOX");
                        ui.viptb.attr("src", "file://res/vip_n.png");
                    })
                })
                toast("自动登录失败\n" + kmdl.ts);
            }
        }
    })
})

//主页的按钮数组，这么设计的原因是往后可能增加主页按钮的自定义添加，现在有侧边栏列表所以暂时没加。
let cclb = [{
    m: "申请权限",
    l: "sqqx"
}, {
    m: "打开浮窗",
    l: "dkfc"
}, {
    m: "退出应用",
    l: "tcyy"
}, {
    m: "打开游戏",
    l: "dkyx"
}]
ui.czlb.setDataSource(cclb);
ui.czlb.on("item_click", function(item, i, itemView, listView) {
    switch (item.l) {
        case "sqqx":
            if (!$floaty.checkPermission()) {
                $floaty.requestPermission();
            }
            break;
        case "dkfc":
            if (gcsj.wlyz.kg && !gcsj.wlyz.yzjg.cb) {
                if (ui.yhs.getText() == "登录中") {
                    toast("正在登陆");
                } else {
                    ui.drawer.openDrawer(3);
                    toast("请先登陆");
                }
                return;
            }
            打开悬浮窗();
            break;
        case "tcyy":
            exit();
            break;
        case "dkyx":
            let bmsl = gcsj.bmlb.length;
            let bmlb = [];
            for (let i = 0; i < bmsl; i++) {
                if (app.getAppName(gcsj.bmlb[i].bm) != null) {
                    bmlb.push(gcsj.bmlb[i]);
                }
            }
            if (bmlb.length == 0) {
                toast("未找到游戏");
            } else if (bmlb.length == 1) {
                launch(bmlb[0].bm);
            } else {
                var bmxzui = ui.inflate(
                    <linear orientation="vertical">
                                <text w="*" h="auto" margin="10 4" textSize="16sp" textColor="#FFFFFF" text="由于您安装了多个目标应用，请您手动选择包名。"/>
                                <View bg="#5A5A5C" h="1" w="*"/>
                                <list id="bmlb" w="*" layout_weight="1">
                                    <linear id="xx" w="*" h="auto" orientation="vertical" foreground="?selectableItemBackground">
                                        <text id="gnm" margin="10 4" w="*" h="auto" padding="0 6 3 8"  textSize="16sp" textColor="#FFFFFF" text="{{this.bz}}" lines="1" ellipsize="end"/>
                                        <View bg="#5A5A5C" h="1" w="*"/>
                                    </linear>
                                </list>
                            </linear>, null, false);

                let bmxztc = dialogs.build({
                    customView: bmxzui,
                    wrapInScrollView: false,
                    type: "app",
                });
                xfcbg(bmxztc.getWindow());
                bmxzui.bmlb.setDataSource(bmlb);
                bmxzui.bmlb.on("item_click", function(item, i, itemView, listView) {
                    launch(item.bm);
                    bmxztc.dismiss();
                })
                bmxztc.show();
            }
            break;
    }
})

//监听登录
ui.yhxx.on('click', () => {
    if (!gcsj.wlyz.kg) {
        toast("无需登录");
        return;
    }
    if (ui.yhs.getText() == "登录中") {
        toast("正在登录，请稍后..");
        return;
    }
    var kmdlui = ui.inflate(
        <linear orientation="vertical">
                    <input id="km" w="*" h="auto" margin="22 4" textColorHint="#DDDDDD" textSizeHint="14sp" hint="卡密" textSize="14sp" textColor="#FFFFFF" singleLine="true" text=""/>
                </linear>, null, false);
    kmdlui.km.setText(storage.get("kami", ""));
    let kmdltc = dialogs.build({
        customView: kmdlui,
        title: "卡密登录",
        titleColor: "#FFFFFF",
        positive: "登录",
        positiveColor: "#FFFFFF",
        negative: "取消",
        negativeColor: "#FFFFFF",
        neutral: "解绑",
        neutralColor: "#FFFFFF",
        wrapInScrollView: false,
        type: "app",
    });
    xfcbg(kmdltc.getWindow());
    kmdltc.on("positive", (input) => {
        let km = kmdlui.km.getText();
        if (km == "") {
            toast("卡密不得为空");
            return;
        }
        ui.yhm.setText(km);
        ui.yhs.setText("登录中");
        ui.viptb.attr("src", "file://res/vip_n.png");
        threads.start(function() {
            let kmdl = 卡密登录(km);
            if (kmdl.cb) {
                ui.run(function() {
                    ui.yhm.setText(km);
                    ui.yhs.setText("到期时间：" + kmdl.ts);
                    ui.viptb.attr("src", "file://res/vip_y.png");
                })
                storage.put("kami", km);
                toast("登录成功");
            } else {
                ui.run(function() {
                    ui.yhm.setText("未登录");
                    ui.yhs.setText("AIJIBIJI GGBOX");
                    ui.viptb.attr("src", "file://res/vip_n.png");
                })
                toast("登录失败\n" + kmdl.ts);
            }
        })
    }).on("negative", () => {

    }).on("neutral", () => {
        let km = kmdlui.km.getText();
        threads.start(function() {
            let kmjb = 卡密解绑(km);
            if (kmjb.cb) {
                storage.put("kami", "");
                toast("解绑成功");
            } else {
                toast("解绑失败\n" + kmjb.ts);
            }
        })
    }).show();
})

ui.cdlb.setDataSource(gcsj.cblb);
//监听功能列表单击事件
ui.cdlb.on("item_click", function(item, i, itemView, listView) {
    app.openUrl(item.url);
})

//设置主页工具栏右上角选项
ui.emitter.on("create_options_menu", menu => {
    menu.add("设置");
    menu.add("关于");
});
//监听主页工具栏右上角选项
ui.emitter.on("options_item_selected", (e, item) => {
    switch (item.getTitle()) {
        case "设置":
            toast("还没有设置");
            break;
        case "关于":
            toast("还没有关于");
            break;
    }
})
activity.setSupportActionBar(ui.zygjl);
//让工具栏左上角可以打开侧拉菜单
ui.zygjl.setupWithDrawer(ui.drawer);


let btsz = [gcsj.gcm];
let gnjl = [];
let dw = device.width;
let dh = device.height;
let 目标进程 = {
    bm: "无",
    pid: -1
};
let pmfxjl = qpmfx();
var rawWindow_xfq;
var rawWindow_xfc;
let rawWindow_bg;
shell("chmod -R 777 " + files.path(".//777/"), false);

//记录按键被按下时的触摸坐标
var x, y;
//记录按键被按下时的悬浮窗位置
var windowX, windowY;
let xfqdx = dw * 0.125;

function zdysz(xgzsz) {
    let zdy = [];
    for (let i = 0; i < xgzsz.length; i++) {
        if (xgzsz[i].zd) {
            zdy.push({
                x: i,
                z: xgzsz[i].sz,
                b: xgzsz[i].bz,
            })
        }
    }
    return zdy;
}

function shell_java(commandArr) { //必要时手动把命令拆成数组确保稳定运行，如：cd到含特殊字符、空格的文件夹等。可以直接传命令字符串。
    let tempBuffer = java.lang.reflect.Array.newInstance(java.lang.Byte.TYPE, 1024);
    let byteArrayOutputStream = new java.io.ByteArrayOutputStream();
    try {
        let exec = java.lang.Runtime.getRuntime().exec(commandArr);
        exec.getOutputStream().close();
        let inputStream = exec.getInputStream();
        let bufferedInputStream = new java.io.BufferedInputStream(inputStream);
        let count;
        while ((count = bufferedInputStream.read(tempBuffer)) !== -1) {
            byteArrayOutputStream.write(tempBuffer, 0, count);
        }
        bufferedInputStream.close();
        let retCode = exec.waitFor();
        exec.destroy();
    } catch (e) {
        //console.error($debug.getStackTrace(e));
        return "执行失败";
    }
    return zhdhc(String(byteArrayOutputStream));
}

function ftzjx(sz) {
    let len = sz.length;
    if (len == 0) {
        return "null";
    }
    let zf = "";
    for (let i = 0; i < len; i++) {
        zf += sz[i].py + ":" + sz[i].lx + "=" + sz[i].sz + (i + 1 == len ? "" : "_");
    }
    return zf;
}

function xgzjx(sz) {
    let len = sz.length;
    if (len == 0) {
        return "null";
    }
    let zf = "";
    for (let i = 0; i < len; i++) {
        zf += sz[i].py + ":" + (sz[i].dj ? "1" : "0") + ":" + sz[i].lx + "=" + sz[i].sz + (i + 1 == len ? "" : "_");
    }
    return zf;
}

function zzjx(sz) {
    let len = sz.length;
    if (len == 0) {
        return "null";
    }
    let zf = "";
    for (let i = 0; i < len; i++) {
        zf += sz[i] + (i + 1 == len ? "" : "_");
    }
    return zf;
}

function bmjx(sz) {
    let len = sz.length;
    if (len == 0) {
        return "null";
    }
    let zf = "";
    for (let i = 0; i < len; i++) {
        zf += sz[i].bm + (i + 1 == len ? "" : "-");
    }
    return zf;
}

function mlcsjx(gnlx, gnsj) {
    let mlzf = "";
    switch (gnlx) {
        case "pyss":
            mlzf += "pyss" + "/";
            mlzf += bmjx(gcsj.bmlb) + "/";
            mlzf += gnsj.ncfw.lx + ":" + gnsj.ncfw.px + ":" + gnsj.ncfw.ks + "~" + gnsj.ncfw.jw + "/";
            mlzf += gnsj.ztz.lx + "=" + gnsj.ztz.sz + "/";
            mlzf += ftzjx(gnsj.ftz) + "/";
            mlzf += xgzjx(gnsj.xgz) + "/";
            mlzf += gnsj.md5;
            break;
        case "zzss":
            mlzf += "zzss" + "/";
            mlzf += bmjx(gcsj.bmlb) + "/";
            mlzf += gnsj.mkt.lx + ":" + gnsj.mkt.xh + ":" + gnsj.mkt.mc + "/";
            mlzf += zzjx(gnsj.zzl) + "/";
            mlzf += ftzjx(gnsj.ftz) + "/";
            mlzf += xgzjx(gnsj.xgz) + "/";
            mlzf += gnsj.md5;
            break;
    }
    return mlzf;
}

function mlcsbm(mlcs) {
    let text = mlcs;
    text = new java.lang.String(text).getBytes();
    text = base64编码(text);
    text = new java.lang.String(text);
    return text;
}

function qmlt(root) {
    let wjlj = files.path(".//777/ggbox");
    if (root) {
        return ["su", "-c", wjlj];
    } else {
        return [wjlj];
    }
}

function zhdhc(text) {
    while (text.slice(-1) == "\n") {
        text = text.slice(0, -1);
    }
    return text;
}

function zxgnml(item) {
    let mlsz = files.path(".//777/ggbox") + " " + mlcsjx(item.gnl, item.gnsj);
    let jg = shell(mlsz, shell_root);
    if (jg.code == 0) {
        rzsz.push({
            bt: ljbtsz(btsz) + item.gnm + "：",
            nr: zhdhc(jg.result),
        });
    } else {
        rzsz.push({
            bt: ljbtsz(btsz) + item.gnm + "：",
            nr: "调用失败",
        });
    }
}

let xfqdjcs = 0;
let xfqyxca = false;
let xfqyxdj = false;

function 打开悬浮窗() {
    if (!$floaty.checkPermission()) {
        toast("没有悬浮窗权限");
        return;
    }
    if (rawWindow_xfq == undefined) {
        rawWindow_xfq = floaty.rawWindow(
            <frame id="xfq" w="*" h="*">
                <img id="xfqtb" w="*" h="*" borderWidth="2" borderColor="#FFFFFF" circle="true" scaleType="fitXY" src="file://res/xfq.png"/>
            </frame>
        );
        rawWindow_xfq.setSize(xfqdx, xfqdx);
        rawWindow_xfq.setPosition(dw - xfqdx, dw);

        rawWindow_xfq.xfq.setOnTouchListener(function(view, event) {
            switch (event.getAction()) {
                case event.ACTION_DOWN: //按下
                    xfqdjcs++;
                    xfqyxdj = true;
                    xfqyxca = true;
                    x = event.getRawX();
                    y = event.getRawY();
                    windowX = rawWindow_xfq.getX();
                    windowY = rawWindow_xfq.getY();
                    let jldjcs = xfqdjcs;
                    setTimeout(function() {
                        if (jldjcs == xfqdjcs && xfqyxca) {
                            if (Math.abs(event.getRawY() - y) < 5 && Math.abs(event.getRawX() - x) < 5) {
                                xfqyxdj = false;
                                device.vibrate(8);
                                threads.start(function() {
                                    let mlsz = files.path(".//777/ncbhjc");
                                    for (let i = 0; i < gcsj.bmlb.length; i++) {
                                        mlsz += " " + gcsj.bmlb[i].bm;
                                    }
                                    let jg = shell(mlsz, shell_root);
                                    toast("内存过保");
                                })
                            }
                        }
                    }, 500);
                    return true;
                case event.ACTION_MOVE: //移动
                    //移动手指时调整悬浮窗位置
                    rawWindow_xfq.setPosition(windowX + (event.getRawX() - x), windowY + (event.getRawY() - y));
                    return true;
                case event.ACTION_UP: //松开
                    //手指弹起时如果偏移很小则判断为点击
                    if (xfqyxdj && Math.abs(event.getRawY() - y) < 5 && Math.abs(event.getRawX() - x) < 5) {
                        xfqyxca = false;
                        if (rawWindow_xfc.getX() == 0) {
                            rawWindow_xfc.setPosition(-dw, 0);
                        } else {
                            rawWindow_xfc.setPosition(0, 0);
                        }
                    }
                    xfqxz(rawWindow_xfq)
                    return true;
            }
            return true;
        });
        threads.start(function() {
            setInterval(() => {
                let dqpmfx = qpmfx();
                if (pmfxjl != dqpmfx) {
                    pmfxjl = dqpmfx;
                    xfqxz(rawWindow_xfq);
                }
            }, 1000)
        })
    } else {
        rawWindow_xfq.setPosition(dw - xfqdx, dw);
    }

    if (rawWindow_xfc == undefined) {
        rawWindow_xfc = floaty.rawWindow(
            <linear id="bg" orientation="vertical" margin="12">
                <linear w="*" h="auto" gravity="center_vertical">
                    <img id="fhsc" w="40" h="40" padding="8" scaleType="fitXY" tint="#FFFFFF" src="drawable/md_nav_back" foreground="?selectableItemBackground"/>
                    <View bg="#5A5A5C" h="*" w="1"/>
                    <text id="cdbt" h="*" layout_weight="1" padding="6 0" gravity="center_vertical" textStyle="bold" textSize="14sp" textColor="#FFFFFF" text="主页/" lines="1" ellipsize="start" foreground="?selectableItemBackground"/>
                    <View bg="#5A5A5C" h="*" w="1"/>
                    <img id="log" w="40" h="40" padding="8" scaleType="fitXY" tint="#FFFFFF" src="drawable/ic_assignment_black_48dp" foreground="?selectableItemBackground"/>
                    <View bg="#5A5A5C" h="*" w="1"/>
                    <img id="gbxfc" w="40" h="40" padding="8" scaleType="fitXY" tint="#FFFFFF" src="drawable/ic_clear_white_48dp" foreground="?selectableItemBackground"/>
                </linear>
                <View bg="#5A5A5C" h="1" w="*"/>
                <viewpager id="viewpager" w="*" layout_weight="1">
                    <list id="gnlb" w="*" layout_weight="1">
                        <linear w="*" h="auto" orientation="vertical" foreground="?selectableItemBackground">
                            <linear w="*" h="auto" gravity="center_vertical">
                                <text layout_weight="1" h="auto" padding="8 8 4 8" textSize="14sp" textColor="#FFFFFF" text="{{this.gnm}}" lines="1" ellipsize="end"/>
                                <progressbar id="jdt" w="auto" h="*" padding="2" visibility="{{(this.czz)?'visible':'gone'}}"/>
                                <img id="gbxfc" w="40" h="40" padding="6" scaleType="fitXY" tint="#cccccc" src="drawable/ic_chevron_right_black_48dp" visibility="{{(this.gnl=='gncd')?'visible':'gone'}}"/>
                            </linear>
                            <View bg="#5A5A5C" h="1" w="*"/>
                        </linear>
                    </list>
                    <list id="rzlb" w="*" layout_weight="1">
                        <linear w="*" h="auto" orientation="vertical" foreground="?selectableItemBackground">
                            <text w="*" h="auto" padding="8 4 8 0" textSize="12sp" textColor="#999999" text="{{this.bt}}"/>
                            <text w="*" h="auto" padding="8 0 8 4" textSize="12sp" textColor="#999999" text="{{this.nr}}"/>
                            <View bg="#5A5A5C" h="1" w="*"/>
                        </linear>
                    </list>
                </viewpager>
            </linear>
        );
        xfcbg(rawWindow_xfc.bg);
        rawWindow_xfc.setSize(dw * 0.75, dw);
        rawWindow_xfc.setPosition(0, 0);
        rawWindow_xfc.cdbt.setText(ljbtsz(btsz));
        rawWindow_xfc.gnlb.setDataSource(gcsj.gnlb);
        rawWindow_xfc.rzlb.setDataSource(rzsz);

        //监听悬浮窗返回键
        rawWindow_xfc.fhsc.on('click', () => {
            if (rawWindow_xfc.viewpager.currentItem == 1) {
                rawWindow_xfc.viewpager.currentItem = 0;
                return;
            }
            if (gnjl.length > 0) {
                if (!sfczz(gnjl)) {
                    gnjl.pop();
                    btsz.pop();
                    rawWindow_xfc.cdbt.setText(ljbtsz(btsz));
                    var gnlbzz = gcsj.gnlb;
                    for (let i = 0; i < gnjl.length; i++) {
                        gnlbzz = gnlbzz[gnjl[i]].gnlb;
                    }
                    rawWindow_xfc.gnlb.setDataSource(gnlbzz);
                }
            }
        })
        //监听日志
        rawWindow_xfc.cdbt.on('click', () => {
            if (rawWindow_xfc.viewpager.currentItem != 0) {
                rawWindow_xfc.viewpager.currentItem = 0;
            }
        })
        //监听日志
        rawWindow_xfc.log.on('click', () => {
            if (rawWindow_xfc.viewpager.currentItem != 1) {
                rawWindow_xfc.viewpager.currentItem = 1;
            }
        })
        //监听悬浮窗关闭键
        rawWindow_xfc.gbxfc.on('click', () => {
            rawWindow_xfc.setPosition(-device.width, 0);
        })
        //监听功能列表单击事件
        rawWindow_xfc.gnlb.on("item_click", function(item, i, itemView, listView) {
            if (item.czz) {
                return;
            }
            if (item.gnl == "gncd") {
                if (!sfczz(gnjl)) {
                    gnjl.push(i);
                    btsz.push(item.gnm);
                    ui.run(function() {
                        rawWindow_xfc.cdbt.setText(ljbtsz(btsz));
                        rawWindow_xfc.gnlb.setDataSource(item.gnlb);
                    })
                }
                return;
            }
            if (item.gnl == "gnhj") {
                item.czz = true;
                ui.run(function() {
                    itemView.jdt.setVisibility(0);
                })
                threads.start(function() {
                    let mlsz = files.path(".//777/ggbox");
                    for (let i = 0; i < item.gnlb.length; i++) {
                        mlsz += " " + mlcsjx(item.gnlb[i].gnl, item.gnlb[i].gnsj);
                    }
                    let jg = shell(mlsz, shell_root);
                    if (jg.code == 0) {
                        rzsz.push({
                            bt: ljbtsz(btsz) + item.gnm + "：",
                            nr: zhdhc(jg.result),
                        });
                    } else {
                        rzsz.push({
                            bt: ljbtsz(btsz) + item.gnm + "：",
                            nr: "调用失败",
                        });
                    }
                    ui.run(function() {
                        itemView.jdt.setVisibility(8);
                    })
                    item.czz = false;
                })
                return;
            }
            item.czz = true;
            ui.run(function() {
                itemView.jdt.setVisibility(0);
            })
            let ftzdsz = zdysz(item.gnsj.ftz);
            let xgzdsz = zdysz(item.gnsj.xgz);
            if (ftzdsz.length > 0 || xgzdsz.length > 0) {
                let zdymb = (ftzdsz.length > 0) ? 1 : 2;
                let zdyui = ui.inflate(
                    <linear orientation="vertical">
                                <text id="tcbt" h="*" layout_weight="1" padding="8" gravity="center_vertical" textStyle="bold" textSize="16sp" textColor="#FFFFFF" text="自定义特征" lines="1" ellipsize="start"/>
                                <View bg="#5A5A5C" h="1" w="*"/>
                                <list id="ftzlb" w="*" layout_weight="1" margin="0">
                                    <linear w="*" h="auto" orientation="vertical">
                                        <text w="*" h="auto" margin="12 4 12 0" textSize="12sp" alpha="0.6" textColor="#FFFFFF" text="{{this.b}}"/>
                                        <input id="sz" w="*" h="auto" margin="8 0 8 0" padding="4 0 4 8" textColorHint="#AAAAAA" textSizeHint="14sp" hint="{{this.z}}" textSize="14sp" textColor="#FFFFFF" digit="1234567890-" singleLine="true" text="{{this.z}}"/>
                                        <View bg="#5A5A5C" h="1" w="*"/>
                                    </linear>
                                </list>
                                <linear w="*" h="auto">
                                    <text id="ftzqx" h="auto" layout_weight="1" margin="0" padding="8" gravity="center" text="取消" textColor="#FFFFFF" textSize="16sp" maxLines="1" ellipsize="end" foreground="?selectableItemBackground"/>
                                    <View bg="#5A5A5C" h="*" w="1"/>
                                    <text id="ftzqr" h="auto" layout_weight="1" margin="0" padding="8" gravity="center" text="确认" textColor="#FFFFFF" textSize="16sp" maxLines="1" ellipsize="end" foreground="?selectableItemBackground"/>
                                </linear>
                            </linear>, null, false);
                if (zdymb == 1) {
                    zdyui.tcbt.setText("自定义特征");
                    zdyui.ftzlb.setDataSource(ftzdsz);
                } else if (zdymb == 2) {
                    zdyui.tcbt.setText("自定义修改");
                    zdyui.ftzlb.setDataSource(xgzdsz);
                }
                zdyui.ftzlb.on("item_bind", function(itemView, itemHolder) {
                    itemView.sz.addTextChangedListener({
                        afterTextChanged: function(text) {
                            if (zdymb == 1) {
                                ftzdsz[itemHolder.position].z = text;
                            } else if (zdymb == 2) {
                                xgzdsz[itemHolder.position].z = text;
                            }
                        }
                    });
                })
                let zdytc = dialogs.build({
                    customView: zdyui,
                    wrapInScrollView: false,
                    type: "overlay"
                });
                zdyui.ftzqx.on("click", function() {
                    zdytc.dismiss();
                });
                zdyui.ftzqr.on("click", function() {
                    if (zdymb == 1) {
                        for (let i = 0; i < ftzdsz.length; i++) {
                            item.gnsj.ftz[ftzdsz[i].x].sz = ftzdsz[i].z;
                        }
                        if (xgzdsz.length > 0) {
                            zdymb = 2;
                            zdyui.tcbt.setText("自定义修改");
                            zdyui.ftzlb.setDataSource(xgzdsz);
                        } else {
                            zdytc.dismiss();
                            threads.start(function() {
                                zxgnml(item);
                                item.czz = false;
                                ui.run(function() {
                                    itemView.jdt.setVisibility(8);
                                })
                            })
                        }
                    } else if (zdymb == 2) {
                        for (let i = 0; i < xgzdsz.length; i++) {
                            item.gnsj.xgz[xgzdsz[i].x].sz = xgzdsz[i].z;
                        }
                        zdytc.dismiss();
                        threads.start(function() {
                            zxgnml(item);
                            item.czz = false;
                            ui.run(function() {
                                itemView.jdt.setVisibility(8);
                            })
                        })
                    }
                });
                xfcbg(zdytc.getWindow());
                zdytc.on("dismiss", (dialog) => {
                    item.czz = false;
                    itemView.jdt.setVisibility(8);
                }).show();
                zdytc.show();
            } else {
                threads.start(function() {
                    zxgnml(item);
                    item.czz = false;
                    ui.run(function() {
                        itemView.jdt.setVisibility(8);
                    })
                })
            }
        })
        //监听功能列表单击事件
        rawWindow_xfc.rzlb.on("item_click", function(item, i, itemView, listView) {
            setClip(item.bt + "：\n" + item.nr);
            toast("已复制")
        })
    } else {
        rawWindow_xfc.setPosition(0, 0);
    }
}

function sfczz(gnjl) {
    var gnlbzz = gcsj.gnlb;
    for (let i = 0; i < gnjl.length; i++) {
        gnlbzz = gnlbzz[gnjl[i]].gnlb;
    }
    for (let i = 0; i < gnlbzz.length; i++) {
        //log(gnlbzz[i].gnm);
        //log(gnlbzz[i].czz);
        if (gnlbzz[i].czz) {
            return true;
        }
    }
    return false;
}

function 关闭悬浮窗() {
    if (rawWindow_xfq != undefined) {
        rawWindow_xfq.setPosition(-dw, 0);
    }
    if (rawWindow_xfc != undefined) {
        rawWindow_xfc.setPosition(-dw, 0);
    }
}

function xfcbg(sss) {
    var bgsz = ["#f01E1F21", "#f025282d", "#f01a1c19"];
    for (let i = 0; i < bgsz.length; i++) {
        bgsz[i] = colors.parseColor(bgsz[i]);
    }
    var gradientDrawable = new GradientDrawable();
    gradientDrawable.setShape(GradientDrawable.RECTANGLE);
    gradientDrawable.setColors(bgsz);
    gradientDrawable.setGradientType(GradientDrawable.LINEAR_GRADIENT); //设置线性渐变
    gradientDrawable.setOrientation(GradientDrawable.Orientation.TR_BL); //设置渐变方向
    gradientDrawable.setSize(100, 100);
    gradientDrawable.setStroke(4, colors.parseColor("#5A5A5C"));
    gradientDrawable.setCornerRadius(18);
    sss.setBackgroundDrawable(gradientDrawable);
}

function xfqxz() {
    let xfqx = rawWindow_xfq.getX();
    let xfqy = rawWindow_xfq.getY();
    let xzx = xfqx; //修正x
    let xzy = xfqy; //修正y
    if (pmfxjl) {
        if (xfqx < 0) {
            xzx = 0;
        } else if (xfqx + rawWindow_xfq.getHeight() > dh) {
            xzx = dh - rawWindow_xfq.getHeight();
        }
        if (xfqy < 0) {
            xzy = 0;
        } else if (xfqy + rawWindow_xfq.getWidth() > dw) {
            xzy = dw - rawWindow_xfq.getWidth();
        }
    } else {
        if (xfqx < 0) {
            xzx = 0;
        } else if (xfqx + rawWindow_xfq.getHeight() > dw) {
            xzx = dw - rawWindow_xfq.getHeight();
        }
        if (xfqy < 0) {
            xzy = 0;
        } else if (xfqy + rawWindow_xfq.getWidth() > dh) {
            xzy = dh - rawWindow_xfq.getWidth();
        }
    }
    rawWindow_xfq.setPosition(xzx, xzy);
}

function qpmfx() {
    let config = context.getResources().getConfiguration();
    let ori = config.orientation;
    if (ori == config.ORIENTATION_LANDSCAPE) {
        //横屏
        return true;
    } else if (ori == config.ORIENTATION_PORTRAIT) {
        //竖屏
        return false;
    }
};

function ljbtsz(btsz) {
    let lj = "";
    for (let i = 0; i < btsz.length; i++) {
        lj = lj + btsz[i] + "/";
    }
    return lj;
}

function 检测更新() {
    try {
        var time = Date.parse(new Date()) / 1000 - 3;
        var res = http.get(gcsj.wlyz.sj.url + "id=ini&app=" + gcsj.wlyz.sj.appid);
        if (res.statusCode == 200) {
            var r = res.body.string();
            r = base64解码(r)
            r = decryptDES(r, gcsj.wlyz.sj.deskey)
            r = new java.lang.String(r)
            r = eval('(' + r + ')');
            if (r.code == 200) {
                if (files.path(".//777/").indexOf("/脚本/") == -1 && app.versionName != r.msg.version) {
                    let gxtc = dialogs.build({
                        title: "发现新版本",
                        titleColor: "#FFFAFAFA",
                        content: r.msg.app_update_show,
                        contentColor: "#FFFAFAFA",
                        positive: "更新",
                        positiveColor: "#FFFAFAFA",
                        negative: "取消",
                        negativeColor: "#FFFFFF",
                        neutral: "复制链接",
                        neutralColor: "#FFFAFAFA",
                        type: "app"
                    });
                    xfcbg(gxtc.getWindow());
                    gxtc.on("positive", (dialog) => {
                        app.openUrl(r.msg.app_update_url);
                    }).on("neutral", (dialog) => {
                        setClip(r.msg.app_update_url);
                        toast("已复制地址");
                    }).on("cancel", (dialog) => {
                        if (r.msg.app_update_must == "y") {
                            exit();
                        }
                    }).show();
                }
            } else {
                toast("检测更新失败\n" + r.msg);
                exit();
            }
        } else {
            toast("检测更新失败\n请求失败");
            exit();
        }
    } catch (error) {
        toast("检测更新失败");
        exit();
    }
}

function 检查公告() {
    var time = Date.parse(new Date()) / 1000 - 3;
    var res = http.get(gcsj.wlyz.sj.url + "id=notice&app=" + gcsj.wlyz.sj.appid);
    if (res.statusCode == 200) {
        var r = res.body.string();
        r = base64解码(r)
        r = decryptDES(r, gcsj.wlyz.sj.deskey)
        r = new java.lang.String(r)
        r = eval('(' + r + ')');
        if (r.code == 200) {
            if (r.msg.app_gg == "") {
                return;
            }
            ui.run(function() {
                ui.ydgoga.setText(r.msg.app_gg);
            })
            let xggmd5 = $crypto.digest(r.msg.app_gg, "MD5");
            let jggmd5 = storage.get("ggmd5", "");
            if (xggmd5 != jggmd5) {
                ui.run(function() {
                    ui.viewpager.currentItem = 1;
                })
            }
            storage.put("ggmd5", xggmd5);
        } else {
            ui.run(function() {
                ui.ydgoga.setText("获取公告失败\n" + r.msg);
            })
        }
    } else {
        ui.run(function() {
            ui.ydgoga.setText("获取公告失败\n请求失败");
        })
    }
}

function 卡密登录(kami) {
    var time = Date.parse(new Date()) / 1000 - 3
    var weivalue = random(1000, 99999) + Date.parse(new Date()) / 1000 - 3;
    var weisign = $crypto.digest("kami=" + kami + "&markcode=" + 获取IMEI() + "&t=" + time + "&" + gcsj.wlyz.sj.appkey, "MD5");
    var weidata = "kami=" + kami + "&markcode=" + 获取IMEI() + "&t=" + time + "&sign=" + weisign + "&value=" + weivalue;
    var weidata = new java.lang.String(weidata).getBytes();
    var weidata = encryptDES(weidata, gcsj.wlyz.sj.deskey)
    weidata = base64编码(weidata)
    var weidata = weidata.replace(/\+/g, "%2B");
    var res = http.get(gcsj.wlyz.sj.url + "id=kmlogon&app=" + gcsj.wlyz.sj.appid + "&data=" + weidata);
    if (res.statusCode == 200) {
        var r = res.body.string();
        r = base64解码(r)
        r = decryptDES(r, gcsj.wlyz.sj.deskey)
        r = new java.lang.String(r)
        r = eval('(' + r + ')');
        var 返回信息 = r.msg;
        if (r.code == gcsj.wlyz.sj.statusCode) {
            gcsj.wlyz.yzjg = {
                cb: true,
                ts: timestampToTime(r.msg.vip),
            };
            return gcsj.wlyz.yzjg;
        } else {
            gcsj.wlyz.yzjg = {
                cb: false,
                ts: r.msg,
            };
            return gcsj.wlyz.yzjg;
        }
    } else {
        gcsj.wlyz.yzjg = {
            cb: false,
            ts: "请求失败",
        };
        return gcsj.wlyz.yzjg;
    }
}

function 获取IMEI() {
    return $crypto.digest(device.fingerprint, "MD5");
}

function 卡密解绑(kami) {
    var time = Date.parse(new Date()) / 1000 - 3
    var weivalue = random(1000, 99999) + Date.parse(new Date()) / 1000 - 3;
    var weisign = $crypto.digest("kami=" + kami + "&markcode=" + 获取IMEI() + "&t=" + time + "&" + gcsj.wlyz.sj.appkey, "MD5");
    var weidata = "kami=" + kami + "&markcode=" + 获取IMEI() + "&t=" + time + "&sign=" + weisign + "&value=" + weivalue;
    var weidata = new java.lang.String(weidata).getBytes();
    var weidata = encryptDES(weidata, gcsj.wlyz.sj.deskey)
    weidata = base64编码(weidata)
    var weidata = weidata.replace(/\+/g, "%2B");
    var res = http.get(gcsj.wlyz.sj.url + "id=kmunmachine&app=" + gcsj.wlyz.sj.appid + "&data=" + weidata);
    if (res.statusCode == 200) {
        var r = res.body.string();
        r = base64解码(r)
        r = decryptDES(r, gcsj.wlyz.sj.deskey)
        r = new java.lang.String(r)
        r = eval('(' + r + ')');
        if (r.code == 200) {
            return {
                cb: true,
                ts: r.msg,
            };
        } else {
            return {
                cb: false,
                ts: r.msg,
            };
        }
    } else {
        return {
            cb: false,
            ts: "请求失败",
        };
    }
}

function timestampToTime(timestamp) {
    // 时间戳为10位需*1000，时间戳为13位的话不需乘1000
    var date = new Date(timestamp * 1000),
        Y = date.getFullYear() + '-', //年份
        M = (date.getMonth() + 1 < 10 ? '0' + (date.getMonth() + 1) : date.getMonth() + 1) + '-', //月份
        D = date.getDate() + ' ', //日期
        h = date.getHours() + ':', //小时
        m = date.getMinutes() + ':', //分钟
        s = date.getSeconds() //秒
    return Y + M + D + h + m + s
}

function base64编码(r) {
    var r = android.util.Base64.encodeToString(r, 0);
    return r
}

function base64解码(r) {
    var r = android.util.Base64.decode(r, 0)
    return r
}

function encryptDES(content, key) {
    var key = new java.lang.String(key).getBytes();
    var random = new SecureRandom();
    var desKey = new DESKeySpec(key);
    var keyFactory = SecretKeyFactory.getInstance("DES");
    var secretKey = keyFactory.generateSecret(desKey);
    // DES 是加密方式, EBC 是工作模式, PKCS5Padding 是填充模式
    var cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
    sss = cipher.init(Cipher.ENCRYPT_MODE, secretKey, random);
    return cipher.doFinal(content);
}

function decryptDES(content, key) {
    var key = new java.lang.String(key).getBytes();
    var random = new SecureRandom();
    var desKey = new DESKeySpec(key);
    var keyFactory = SecretKeyFactory.getInstance("DES");
    var secretKey = keyFactory.generateSecret(desKey);
    var cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
    cipher.init(Cipher.DECRYPT_MODE, secretKey, random);
    return cipher.doFinal(content);
}